#!/bin/sh
# ==========================================
# (C) AO Kaspersky Lab. All Rights Reserved.
# ==========================================

SYSTEM_TYPE=$(uname | tr [:lower:] [:upper:])
HOST_NAME=$(hostname | tr [:upper:] [:lower:])
ERROR=0


if [ $(id -u) -ne 0 ]; then
	echo "This script requires root privileges in order to run!"
	ERROR=1
else

	echo "
	----------------------------------------------------------------------------
	This script collects various system information about your linux/unix/mac host.
	This information is important for Kaspersky Support service.
	You would find the result at /tmp/%hostname%-collect.tar.gz
	PLEASE REMOVE EVERYTHING YOU CONSIDER CONFIDENTIAL BEFORE SENDING
	----------------------------------------------------------------------------
	"
	TMP=/tmp/collect

	mkdir $TMP

	exec 6>&2
	exec 2> $TMP/clog

	echo "collecting environment..."

	TMPE=$TMP/environment
	mkdir $TMPE
	set > $TMPE/set.txt
	env > $TMPE/env.txt

	TMPK=$TMP/kaspersky
	mkdir $TMPK

	echo "06182020" > $TMP/HQ-basic-18

	if [ "$SYSTEM_TYPE" = "DARWIN" ]; then
        launchctl list > $TMPE/launchctl.txt
		memory_pressure > $TMPE/memory.txt
		mount > $TMPE/hdd.txt
		df -h >> $TMPE/hdd.txt
		df -hi >> $TMPE/hdd.txt
		cp /etc/group $TMPE/group
		ps -ef > $TMPE/ps.txt
		uname -a >> $TMPE/uname.txt
		sysctl -a > $TMPE/sysctl.txt
		lsof > $TMPE/lsof.txt
		vm_stat > $TMPE/vmstat.txt
		iostat > $TMPE/iostat.txt
		ulimit -a > $TMPE/ulimit.txt
		netstat -nr > $TMPE/route.txt
		ifconfig > $TMPE/ifconfig.txt
		uptime > $TMPE/uptime.txt
		hostname > $TMPE/hostname.txt
		cp /etc/hosts $TMPE
		cp /etc/resolv.conf $TMPE
		cp -R /etc/periodic/ $TMPE
		date > $TMPE/date.txt
		ping -c2 support.kaspersky.com > $TMPE/ping.txt
		kextstat > $TMPE/kextstat.txt
		system_profiler -detailLevel full -xml > $TMPE/system.spx
		(kav status > $TMPK/kav_status.txt) & sleep 10 ; kill $!
		cp /Library/Application\ Support/Kaspersky\ Lab/KAV/Binaries/config.xml $TMPK/config.xml
		/Library/Application\ Support/Kaspersky\ Lab/klnagent/Binaries/klnagchk > $TMPK/klnagchk.txt
		mkdir $TMPK/connectors
		cp -R /Library/Application\ Support/Kaspersky\ Lab/klnagent_conf/connectors.d/ $TMPK/connectors
		cp -R /Library/Application\ Support/Kaspersky\ Lab/klnagent_conf/connectors64.d/ $TMPK/connectors
		dscl . list /Users | grep -v '_' > $TMPE/users.txt
		spctl kext-consent status > $TMPE/kext_consent.txt
		sqlite3 -separator $'\t' -header /var/db/SystemPolicyConfiguration/KextPolicy "select * from kext_policy" > kext_policy.txt
		cp /etc/sudoers $TMPE/sudoers.txt
		grep 'PasswordAuthentication\|ChallengeResponseAuthentication' /etc/ssh/sshd_config | grep -v '^#' > $TMPE/klnagent.remote.txt


	elif [ "$SYSTEM_TYPE" = "LINUX" ]; then
	    systemctl > $TMPE/systemctl.txt
		pstree > $TMPE/pstree.txt
		cat /proc/cpuinfo > $TMPE/cpuinfo.txt
		free -h > $TMPE/memory.txt
		mount > $TMPE/hdd.txt
		df -h >> $TMPE/hdd.txt
		df -hi >> $TMPE/hdd.txt
		cp /etc/passwd $TMPE/passwd
		cp /etc/group $TMPE/group
		ps axo pid,ppid,pcpu,pmem,rsz,vsz,cmd > $TMPE/ps.txt
		ps axo pid,ppid,pcpu,pmem,rsz,vsz,cmd -T > $TMPE/pst.txt
		cat /etc/issue >$TMPE/uname.txt
		uname -a >> $TMPE/uname.txt
		cat /etc/issue >$TMPE/os_release.txt
		cat /etc/redhat-release >>$TMPE/os_release.txt
		sysctl -a > $TMPE/sysctl.txt
		sestatus > $TMPE/sestatus.txt
		apparmor_status > $TMPE/app_armor.txt
		lsmod > $TMPE/lsmod.txt
		netstat -na > $TMPE/netstat.txt
		lsof > $TMPE/lsof.txt
		ipcs -a > $TMPE/ipcs.txt
		vmstat 1 10 > $TMPE/vmstat.txt & vmstat -d 1 10 > $TMPE/vmstatd.txt & vmstat -m 1 10 > $TMPE/vmstatm.txt & iostat -xk 1 10 > $TMPE/iostat.txt
		vmstat -D > $TMPE/vmstatd2.txt
		vmstat -s > $TMPE/vmstats.txt
		rpm -qa >> $TMPE/packages.txt
		dpkg -l >> $TMPE/packages.txt
		ulimit -a > $TMPE/ulimit.txt
		route -n> $TMPE/route.txt
		ifconfig >$TMPE/ifconfig.txt
		ip a > $TMPE/ipa.txt
		ss -a > $TMPE/ss.txt
		ip -4 route ls > $TMPE/ipv4routes.txt
		ip -4 rule ls > $TMPE/ipv4rules.txt
		ip -6 route ls > $TMPE/ipv6routes.txt
		ip -6 rule ls > $TMPE/ipv6rules.txt
		iptables -nL > $TMPE/iptables.txt
		iptables -nvL -t filter > $TMPE/iptables-filter.txt
        iptables -nvL -t mangle > $TMPE/iptables-mangle.txt
        iptables -nvL -t nat > $TMPE/iptables-nat.txt
		firewall-cmd --list-all-zones > $TMPE/firewalld.zones.txt
		uptime > $TMPE/uptime.txt
		hostname > $TMPE/hostname.txt
		cp /etc/hosts $TMPE
		cp /etc/resolv.conf $TMPE
		cp -RL /etc/cron.d/ $TMPE
		cp -RL /etc/cron.daily/ $TMPE
		cp -RL /etc/cron.weekly/ $TMPE
		cp -RL /etc/cron.monthly/ $TMPE
		cp -RL /etc/cron.hourly/ $TMPE
		cp /etc/crontab $TMPE
		ls -la / /tmp /opt /var /etc  > $TMPE/lsroot.txt
        ls -laR /opt/kaspersky /var/opt/kaspersky > $TMPE/lskasp.txt
		date > $TMPE/date.txt
		ping -c2 support.kaspersky.com > $TMPE/ping.txt
		cp /etc/sudoers $TMPE/sudoers.txt
		grep CONFIG_FANOTIFY /boot/config-$(uname -r) > $TMPE/fanotify.txt
		grep 'PasswordAuthentication\|ChallengeResponseAuthentication' /etc/ssh/sshd_config | grep -v '^#' > $TMPE/klnagent.remote.txt


		cp -RL /etc/opt/kaspersky  $TMPK/etc
		cp -R /var/opt/kaspersky/lmc-agent $TMPK/
		cp -R /var/opt/kaspersky/lmc-server $TMPK/
		cat /var/opt/kaspersky/klms/installer.dat | grep -v installation_id > $TMPK/installer.dat
		cp /var/opt/kaspersky/klms/postgresql/postgresql.conf $TMPK/
		/opt/kaspersky/kav4fs/bin/kav4fs-control --export-settings -F $TMPK/kav4fsset.xml
		/opt/kaspersky/kav4fs/bin/kav4fs-control --get-task-list > $TMPK/kav4fstask.txt
		/opt/kaspersky/kav4fs/bin/kav4fs-control -L --get-installed-keys > $TMPK/kav4fs.lic
		/opt/kaspersky/klms/bin/klms-control --export-settings -f $TMPK/klms8set.xml
		/opt/kaspersky/klms/bin/klms-control --export-rules -f $TMPK/klms8rules.xml
		/opt/kaspersky/klms/bin/klms-control -l --get-installed-keys > $TMPK/klms8.lic
		/opt/kaspersky/klms/bin/klms-control --dashboard --month > $TMPK/klms8.stats
		/opt/kaspersky/kesl/bin/kesl-control --app-info > $TMPK/kesl.appinfo.txt
		/opt/kaspersky/kesl/bin/kesl-control --get-app-set > $TMPK/kesl.appset.txt
		/opt/kaspersky/kesl/bin/kesl-control --get-task-list > $TMPK/kesl.tasklist.txt
		/opt/kaspersky/kesl/bin/kesl-control --get-set 1 > $TMPK/kesl.set1.txt
		find /var/opt/kaspersky/kesl/ > $TMPK/kesl.listing.txt
		/opt/kaspersky/klnagent/bin/klnagchk > $TMPK/klnagchk.txt
		/opt/kaspersky/klnagent64/bin/klnagchk > $TMPK/klnagchk64.txt
		cp /var/opt/kaspersky/kesl/events.db $TMPK/
		cp /opt/kaspesrky/klms/bin/sendmail $TMPK/
		SENDMAIL=$(which sendmail)
		echo "$SENDMAIL" >> $TMPK/lms-sm
		ls -l "$SENDMAIL" >> $TMPK/lms-sm
		ls -l /etc/alternatives >> $TMPK/lms-sm
		ls -l /opt/kaspesrky/klms/bin/sendmail >> $TMPK/lms-sm
		cp -R /var/opt/kaspersky/epagent $TMPK/epagent
	elif [ "$SYSTEM_TYPE" = "FREEBSD" ]; then
        mount > $TMPE/hdd.txt
        df -h >> $TMPE/hdd.txt
        df -hi >> $TMPE/hdd.txt
        cp /etc/passwd $TMPE/passwd
        cp /etc/group $TMPE/group
        kldstat > $TMPE/kldstat.txt
        ipcs -a > $TMPE/ipcs.txt
		top -d1 > $TMPE/top.txt
        vmstat -a > $TMPE/vmstata.txt
		vmstat -f > $TMPE/vmstatf.txt
		vmstat -i > $TMPE/vmstati.txt
		vmstat -m > $TMPE/vmstatm.txt
		sysctl -a > $TMPE/sysctl.txt
		ps axo comm,user,group,state,rss,vsz,pcpu,pmem,time,command >  $TMPE/ps.txt
        ulimit -a > $TMPE/ulimit.txt
		fstat > $TMPE/fstat.txt
		netstat -na > $TMPE/nestat.txt
		netstat -r > $TMPE/route.txt
		iostat -xc 3 > $TMPE/iostat.txt
		pkg_info > $TMPE/pkgi1.txt
		echo "N" | pkg info > $TMPE/pkgi2.txt
		ipfw show  > $TMPE/ipfw.txt
        uptime > $TMPE/uptime.txt
        hostname > $TMPE/hostname.txt
        cp /etc/hosts $TMPE
        cp /etc/resolv.conf $TMPE
        ifconfig > $TMPE/ifconfig.txt
        cp -R /etc/periodic $TMPE
        cp /etc/crontab $TMPE
		ls -la / /tmp /usr/local /var /etc  > $TMPE/lsroot.txt
        ls -laR /usr/local/kaspersky /var/db/kaspersky > $TMPE/lskasp.txt
        date > $TMPE/date.txt
        ping -c2 support.kaspersky.com > $TMPE/ping.txt

		cp -R /usr/local/etc/kaspersky/klms  $TMPK/etc
		cp /var/db/kaspersky/klms/postgresql/postgresql.conf $TMPK/
		klms-control --export-settings -f $TMPK/klms8set.txt
		klms-control --export-rules -f $TMPK/klms8rules.xml
		klms-control -l --get-installed-keys > $TMPK/klms8.lic
		klms-control --dashboard --month > $TMPK/klms8.stats
        SENDMAIL=$(which sendmail)
        echo "$SENDMAIL" >> $TMPK/lms-sm
        ls -l "$SENDMAIL" >> $TMPK/lms-sm
		ls -l /usr/sbin/mailwrapper >> $TMPK/lms-sm
	fi

	echo "logs..."

	TMPL=$TMP/logs
	mkdir $TMPL
	dmesg > $TMPL/dmesg.txt
	ls -laR /var/log/ > $TMPL/log_list.txt

	if [ "$SYSTEM_TYPE" = "DARWIN" ]; then
		tail -1000 /var/log/mail.log > $TMPL/mail.log.txt
		tail -3000 /var/log/system.log > $TMPL/system.log
		tail -3000 /var/log/install.log > $TMPL/install.log
		cp /var/log/kav_daemon_stderr.log $TMPL/kav_daemon_stderr.log
		mkdir $TMPL/mac_traces
		mkdir $TMPL/mac_traces/copy
        mkdir $TMPL/mac_traces/ucopy
        cp /Library/Logs/klnagent_trace.log $TMPL/klnagent_trace.log
        cp '/Library/Application Support/Kaspersky Lab/klnagent/Binaries/$klnagent-1103.log' $TMPL/klnagent-trace.log
		cp -R /Library/Logs/Kaspersky\ Lab/* $TMPL/mac_traces/copy
		cp -R ~/Library/Logs/Kaspersky\ Lab/* $TMPL/mac_traces/ucopy
		cp -R /Library/Logs/DiagnosticReports/ $TMPL/DiagnosticReports/;
		cp -R ~/Library/Logs/DiagnosticReports/ $TMPL/DiagnosticReports/;


	elif [ "$SYSTEM_TYPE" = "LINUX" ]; then
		tail -1000 /var/log/maillog > $TMPL/maillog.txt
		tail -1000 /var/log/mail.log > $TMPL/mail.log.txt
		tail -1000 /var/log/mail.err > $TMPL/mail.err.txt
		tail -1000 /var/log/mail.warn > $TMPL/mail.warn.txt
        tail -1000 /var/log/syslog > $TMPL/syslog.txt
		tail -1000 /var/log/boot.log > $TMPL/bootlog.txt
		tail -1000 /var/log/kern.log > $TMPL/kernlog.txt
		tail -n10 /var/log/upstart/*.log > $TMPL/upstartlog.txt
        tail -1000 /var/log/messages > $TMPL/messages.txt
        tail -1000 /var/log/dmesg > $TMPL/dmesg.txt
		dmesg > $TMPL/dmesg.out.txt
		cp -R /var/log/kaspersky/ $TMPL
		journalctl -n 10000 > $TMPL/journal.txt
		journalctl -p 4 -n 10000 > $TMPL/journal.4.txt
		journalctl -o verbose -p 4 -n 100 > $TMPL/journal.v.4.txt

		if [ $(grep kpsn $TMPE/packages.txt | wc -l) -ne 0 ]; then
		    monit status > $TMPK/monit.txt
		    runuser -l ksnuser -c 'monit status' >> $TMPK/monit.txt
		    mkdir $TMPK/KPSN/
		    mkdir $TMPK/KPSN/pubdata/
		    mkdir $TMPK/KPSN/gateway/
		    mkdir $TMPK/KPSN/etc/
		    find /usr/local/ksn/log/ -type f -newermt $(date +%Y-%m-%d -d '-3 days') -printf "%f\n" -exec cp {} $TMPK/KPSN/ >/dev/null 2>&1 \;
		    cp -R /var/log/apache/ $TMPL
		    cp -R /var/log/httpd/ $TMPL
		    cp -R /usr/local/ksn/var/pubdata/ $TMPK/KPSN
		    cp -R /usr/local/ksn/var/gateway/ $TMPK/KPSN
		    cp -R /usr/local/ksn/etc/ $TMPK/KPSN
		    pip list > $TMPK/KPSN/pip.txt
		fi


	elif [ "$SYSTEM_TYPE" = "FREEBSD" ]; then
		tail -1000 /var/log/maillog > $TMPL/maillog.txt
		tail -1000 /var/log/messages > $TMPL/messages.txt
		dmesg > $TMPL/dmesg.txt
		cp -R /var/log/kaspersky/ $TMPL
	fi


	echo "packing..."
	tar czf /tmp/$HOST_NAME-collect.tar.gz $TMP
	ls -lahR $TMP > /tmp/collect.lst

	echo "cleaning..."
	rm -rf $TMP

	exec 2>&6 6>&-

	echo "All done!"

	if [ "$SYSTEM_TYPE" = "DARWIN" ]; then
		open ${TMP%/*}
	fi

fi

exit $ERROR
